var title_id,content_id,store_product_url,output1,output2,output3,output4;
var xml = "xml", json = "json", notfound="<span class='notfound'> (404...)</span>";
var title_id_reg = /[a-zA-Z]{4}\d{5}/;
var content_id_reg = /[a-zA-Z]{2}\d{4}-[a-zA-Z]{4}\d{5}_(\d{2}|[a-zA-Z]{2})-[a-zA-Z0-9]{16}/;
var tmdb_reject_psp;
var chihiro_r, chihiro_r2;
var titlecontainer_reject, titles, console_name, video_flag;
var valkyrie_hit, search_titles, search_index, search_titles_len;

function InputDisable(){
	$("#input_key").prop('disabled', true);
	$("#tmdb").prop('disabled', true);
	$("#update").prop('disabled', true);
	$("#chihiro").prop('disabled', true);
	$("#selectbox").prop('disabled', true);
	$("#delete").prop('disabled', true);
}

function InputEnable(){
	$("#input_key").prop('disabled', false);
	$("#tmdb").prop('disabled', false);
	$("#update").prop('disabled', false);
	$("#chihiro").prop('disabled', false);
	$("#selectbox").prop('disabled', false);
	$("#delete").prop('disabled', false);
	$("#input_key").focus();
	$("#delete").show();
	$('#delete').on('click',function(){
		title_id=undefined, content_id=undefined, store_product_url=undefined,
		tmdb_reject_psp=undefined, titlecontainer_reject=undefined, titles=undefined,
		console_name=undefined, video_flag=undefined, valkyrie_hit=undefined,
		search_titles=undefined, search_index=undefined, search_titles_len=undefined;
		output1.empty();output2.empty();output3.empty();output4.empty();
		$("#input_key").val("");
		$("#input_key").focus();
	})
}

function IdCheck(input_key,id_type){
	InputDisable();
	tmdb_reject_psp=false, chihiro_r=null, chihiro_r2=null, titlecontainer_reject=false,
	titles=[], console_name=null, video_flag=false, valkyrie_hit=0, search_titles={};
	if(id_type=="title"){
		title_id = input_key;
		content_id = null;
		store_product_url = null;
	}else if(id_type=="content"){
		title_id = input_key.match(title_id_reg)[0];
		content_id = input_key.match(content_id_reg)[0];
		store_product_url = null;
		titlecontainer_reject = true;
	}else if(id_type=="url"){
		title_id = input_key.match(title_id_reg)[0]
		content_id = input_key.match(content_id_reg)[0];
		store_product_url = input_key;
	}
	output1=$("#output1"),output2=$("#output2"),output3=$("#output3"),output4=$("#output4");
	if(output1.text()!="") output1.empty();output2.empty();output3.empty();output4.empty();

	OutputItem(output1,"Title ID",title_id);
	if(content_id!=null) OutputItem(output1,"Content ID",content_id);
	OutputItem(output1,"Media","");

	var temp=null;
	var prefix = title_id.substring(0,4);
	switch(title_id.substring(0,2)){
		/* PS3 BD */
		case "BC":
		case "BL":
			output1.find("[name='Media']").append("PS3 BD");
			console_name = "ps3";
			PhysicalMedia_RegionCheck();
			PhysicalMedia_TypeCheck();
			PSPPS3_Def();
			break;
		/* PS4 */
		case "CU":
			output1.find("[name='Media']").append("PS4 BD/Digital");
			CID_RegionCheck(output1);
			console_name = "ps4";
			PS4_Def();
			break;
		/* PSVita System, PS4 System, PSM, PSP DL, PS3 DL (including PS1/PS2 Classics) */
		case "NP":
			if(title_id.substring(0,5) == "NPXS1"){
				output1.find("[name='Media']").append("PSVita Digital");
				console_name = "vita";
				OutputItem(output1,"Type","System");
				PSVITA_Def();
			}else if(title_id.substring(0,5) == "NPXS2" || title_id.substring(0,5) == "NPXS3"){
				output1.find("[name='Media']").append("PS4 Digital");
				console_name = "ps4";
				OutputItem(output1,"Type","System");
				PS4_Def();
			}else{
				var psm = PSM_Check(); /* including PSM region check */
				if(!psm){
					if(prefix=="NPMA" || prefix=="NPVA" || prefix=="NPVB"){
						/* Is MPMB a video too? Does MPVB exist because NPVA is depleted? */
						video_flag = true;
						output1.find("[name='Media']").append("Digital (Video)");
						CID_RegionCheck(output1);
						ChihiroCheck();
					}else{
						PSPPS3_NP_RegionCheck();
						PSPPS3_NP_TypeCheck();
						PSPPS3_Def();
					}
				}else{
					/* I don't know what to do for PSM Title ID... */
					InputEnable();
				}
			}
			break;
		/* MRTCxxxxx is PS3 Disc (It means Multi Region Title C....?) */
		case "MR":
			if(prefix=="MRTC"){
				output1.find("[name='Media']").append("PS3 Disc");
				console_name = "ps3";
				OutputItem(output1,"Type","Multi Region Title C....?");
				PSPPS3_Def();
			}else{
				InputEnable();
			}
			break;
		/* PS4 BD , PSVita */
		case "PC":
		/* PS4 BD */
		case "PL":
			if(title_id.substring(0,3) == "PCS"){
				output1.find("[name='Media']").append("PSVita Card/Digital");
				console_name = "vita";
				PSVITA_RegionTypeCheck();
				PSVITA_Def();
			}else{
				output1.find("[name='Media']").append("PS4 BD");
				console_name = "ps4";
				PhysicalMedia_RegionCheck();
				PhysicalMedia_TypeCheck();
				var notice = "Each check using PS4 BD ID is not supported...<br>"
						+ "If you need an each check, please use a \"CUSAYYYYY\" format Title ID.<br>"
						+ "(YYYYY is number)";
				OutputNotice(output1,notice);
				InputEnable();
			}
			break;
		/* PS1 CD, PS2/PS3 CD/DVD */
		case "SC":
		case "SL":
			output1.find("[name='Media']").append("PS1,PS2,PS3 CD/DVD");
			PhysicalMedia_RegionCheck();
			PhysicalMedia_TypeCheck();
			InputEnable();
			break;
		/* PSP UMD */
		case "UC": 
		case "UL":
			output1.find("[name='Media']").append("PSP UMD");
			console_name = "psp";
			tmdb_reject_psp = true;
			PhysicalMedia_RegionCheck();
			PhysicalMedia_TypeCheck();
			PSPPS3_Def();
			break;
		/* PSVita Card */
		case "VC": 
		case "VL":
			output1.find("[name='Media']").append("PSVita Card");
			PhysicalMedia_RegionCheck();
			PhysicalMedia_TypeCheck();
			var notice = "Each check using Vita Card ID is not supported...<br>"
					+ "If you need an each check, please use a \"PCSxYYYYY\" format Title ID.<br>"
					+ "(x is English alphabet / YYYYY is number)";
			OutputNotice(output1,notice);
			InputEnable();
			break;
		/* PS3 BD + Extras (PSVita crossbuy) */
		case "XC": 
		case "XL":
			output1.find("[name='Media']").append("PS3 BD + Extras (PSVita crossbuy)");
			PhysicalMedia_RegionCheck();
			PhysicalMedia_TypeCheck();
			PSPPS3_Def();
			break;
		/*  PS1 and PS2 CS disc */
		case "PE":
			temp = "PS1 and PS2 CS disc for Europe, Australia & Gulf area";
		case "PT":
			if(temp==null) temp = "PS1 and PS2 CS disc for Japan & Asia";
		case "PU":
			if(temp==null) temp = "PS1 and PS2 CS disc for USA & Canada";
			output1.find("[name='Media']").append(temp);
			PhysicalMedia_RegionCheck();
			PhysicalMedia_TypeCheck();
			InputEnable();
			break;
		/* Others */
		default :
			output1.find("[name='Media']").append("?");
			var notice = "This Title ID isn't supported for Tmdb check and Update check.";
			OutputNotice(output1,notice);
			ChihiroCheck();
			break;
	}
}


/* PSP/PS3 - Deferred */
function PSPPS3_Def(){
	PS3PS4_TmdbCheck().then(
		function(data){
			var def = new $.Deferred();
			PS3_TmdbOut(data,def)
			return def.promise();
		},function(){
			$(".tmdb").append(notfound);
			return $.Deferred().resolve().promise();
		}
	).then(
		function(){
			var def = new $.Deferred();
			PSPPS3_UpdateCheck(def);
			return def.promise();
		}
	).then(
		function(data){
			var def = new $.Deferred();
			PSPPS3_UpdateOut(data,def);
			return def.promise();
		},function(){
			$(".update").append(notfound);
			return $.Deferred().resolve().promise();
		}
	).then(
		function(){
			ChihiroCheck();
		}
	);
}


/* PS4 - Deferred */
function PS4_Def(){
	PS3PS4_TmdbCheck().then(
		function(data){
			var def = new $.Deferred();
			PS4_TmdbOut(data,def);
			return def.promise();
		},function(){
			$(".tmdb").append(notfound);
			return $.Deferred().resolve().promise();
		}
	).then(
		function(){
			var def = new $.Deferred();
			PS4_UpdateCheck(def);
			return def.promise();
		}
	).then(
		function(data){
			var def = new $.Deferred();
			PS4_UpdateOut(data,def);
			return def.promise();
		},function(){
			$(".update").append(notfound);
			return $.Deferred().resolve().promise();
		}
	).then(
		function(){
			ChihiroCheck();
		}
	);
}


/* PSVITA - Deferred */
function PSVITA_Def(){
	PSVITA_UpdateCheck().then(
		function(data){
			var def = new $.Deferred();
			PSVITA_UpdateOut(data,def);
			return def.promise();
		},function(){
			$(".update").append(notfound);
			return $.Deferred().resolve().promise();
		}
	).then(
		function(){
			ChihiroCheck();
		}
	);
}


/* BD/UMD/Card - Region Check */
function PhysicalMedia_RegionCheck(){
	var right,region;
	if(title_id.substring(1,2) == "C"){
		right = "First Party";
	}else if(title_id.substring(1,2) == "L"){
		right = "Third Party";
	}
	switch(title_id.substring(2,3)){
		case "A":
			region = "Asia";
			chihiro_r = "ASIA";
			break;
		case "E":
			region = "Europe";
			chihiro_r = "EU";
			break;
		case "J":
			region = "Japan";
			chihiro_r = "JP";
			break;
		case "H":
			region = "Hong Kong";
			chihiro_r = "HK";
			break;
		case "K":
			region = "Korea";
			chihiro_r = "KR";
			break;
		case "U":
			region = "USA";
			chihiro_r = "US";
			break;
		case "P":	/* PS1,PS2_Disc */
			region = "Japan";
			break;
		default :
			region = "?";
			break;
	}
	OutputItem(output1,"Region",region);
	OutputItem(output1,"Rights",right)
}


/* BD/UMD/Card - Type Check */
function PhysicalMedia_TypeCheck(){
	var type;
	switch(title_id.substring(3,4)){
		case "B":
			type = "Peripheral Software";
			break;
		case "C":
			type = "System Firmware";
			break;
		case "D":
			type = "Demo";
			break;
		case "M":
			type = "Retail release";
			break;
		case "S":
			type = "Retail release";
			break;
		case "T":
			type = "(closed) Betas";
			break;
		case "V":
			type = "Multi Region PS3 CS disc";
			break;
		case "X":
			type = "Install disc? (Demos, Store Videos)";
			break;
		case "Z":
			type = "Region locked PS3 CS disc";
			break;
		default :
			type = "?";
			break;
	}
	OutputItem(output1,"Type",type)
}


/* PSM Check */
function PSM_Check(){
	var region = null;
	var psm = true;
	switch(title_id.substring(2,3)){
		case "N":
			region = "USA";
			chihiro_r = "US";
			break;
		case "O":
			region = "Europe";
			chihiro_r = "EU";
			break;
		case "P":
			region = "Japan";
			chihiro_r = "JP";
			break;
		case "Q":
			region = "Asia";
			chihiro_r = "ASIA";
			break;
		default :
			psm = false;
		 break;
	}
	if(region!=null){
		output1.find("[name='Media']").append("Digital(PSM)");
		OutputItem(output1,"Region",region);
	}
	return psm;
}


/* PSVita(PCSxYYYYY)- Region&Type Check */
function PSVITA_RegionTypeCheck(){
	var region,right;
	switch(title_id.substring(3,4)){
		case "A":
			region ="US";
			right = "First Party";
			chihiro_r = "US";
			break;
		case "B":
			region ="Europe";
			right = "Third Party";
			chihiro_r = "EU";
			break;
		case "C":
			region ="Japan";
			right = "First Party";
			chihiro_r = "JP";
			break;
		case "D":
			region ="Asia/Korea";
			right = "First Party";
			chihiro_r = "ASIA";
			break;
		case "E":
			region ="USA";
			right = "Third Party";
			chihiro_r = "US";
			break;
		case "F":
			region ="Europe";
			right = "First Party";
			chihiro_r = "EU";
			break;
		case "G":
			region ="Japan";
			right = "Third Party";
			chihiro_r = "JP";
			break;
		case "H":
			region ="Asia/Korea";
			right = "Third Party";
			chihiro_r = "ASIA";
			break;
		case "I":
			region ="Internal";
			right = "First Party";
			chihiro_r = "US";
			break;
		default :
			region = "?";
			right = "?"
			break;
	}
	OutputItem(output1,"Region",region);
	OutputItem(output1,"Rights",right);
}


/* Content ID - Region Check */
function CID_RegionCheck(out){
	if(content_id!=null){
		var first_letter = content_id.substr(0,1);
		var region;
		switch(first_letter){
			case "J":
				region ="Japan";
				chihiro_r = "JP";
				break;
			case "U":
				region ="USA";
				chihiro_r = "US";
				break;
			case "E":
				region ="Europe";
				chihiro_r = "EU";
				break;
			case "H":
				region ="Asia";
				chihiro_r = "ASIA";
				break;
			case "I":
				region ="Internal";
				chihiro_r = "US";
				break;
			default :
				region = "?";
				break;
		}
		OutputItem(out,"Region",region);
	}
}


/* PSP/PS3 DL - Region Check */
function PSPPS3_NP_RegionCheck(){
	var region;
	switch(title_id.substring(2,3)){
		case "A":
			region = "Asia";
			chihiro_r = "ASIA";
			break;
		case "E":
			region = "Europe";
			chihiro_r = "EU";
			break;
		case "J":
			region = "Japan";
			chihiro_r = "JP";
			break;
		case "H":
			region = "Hong Kong";
			chihiro_r = "HK";
			break;
		case "K":
			region = "Korea";
			chihiro_r = "KR";
			break;
		case "U":
			region = "USA";
			chihiro_r = "US";
			break;
		case "I":
			region = "Internal ? (Sony)";
			chihiro_r = "US";
			break;
		case "X":
			region = "(Firmware/SDK Sample)";
			break;
		default :
			region = "?";
			break;
	}
	OutputItem(output1,"Region",region);
}


/* PSP/PS3 DL - Type Check */
function PSPPS3_NP_TypeCheck(){
	var type;
	var ps3_media = false;
	switch(title_id.substring(3,4)){
		case "A":
			type = "First Party PS3";
			ps3_media = true;
			break;
		case "B":
			type = "Third Party PS3";
			ps3_media = true;
			break;
		case "C":
			type = "First Party PS2 Classic";
			ps3_media = true;
			break;
		case "D":
			type = "Third Party PS2 Classic";
			ps3_media = true;
			break;
		case "E":
			type = "Third Party PS1 Classic (PAL)";
			break;
		case "F":
			type = "First Party PS1 Classic (PAL)";
			break;
		case "G":
			type = "First Party PSP";
			tmdb_reject_psp = true;
			break;
		case "H":
			type = "Third Party PSP";
			tmdb_reject_psp = true;
			break;
		case "I":
			type = "First Party PS1 Classic (NTSC)";
			break;
		case "J":
			type = "Third Party PS1 Classic (NTSC)";
			break;
		case "K":
			type = "First Party Game related Content";
			break;
		case "L":
			type = "Third Party Game related Content";
			break;
		case "M":
			type = "Music";
			break;
		case "N":
			type = "Game Soundtracks";
			break;
		case "O":
			type = "Other";
			break;
		case "P":
		case "Q":
		case "R":
			type = "?";
			break;
		case "S":
			type = "System";
			break;
		case "T":
		case "U":
		case "V":
			type = "?";
			break;
		case "W":
			type = "First Party PSP Remasters";
			ps3_media = true;
			break;
		case "X":
			type = "First Party PSP Minis";
			break;
		case "Y":
			type = "Third Party PSP Remasters";
			ps3_media = true;
			break;
		case "Z":
			type = "Third Party PSP minis";
			break;
		default :
			type = "?";
			break;
	}
	var media_name = "PSP,PS3 Digital";
	if(ps3_media){
		media_name = "PS3 Digital";
		console_name = "ps3"
	}else if(tmdb_reject_psp){
		media_name = "PSP Digital";
		console_name = "psp"
	}
	output1.find("[name='Media']").append(media_name);
	OutputItem(output1,"Type",type);
}


/* PS3/PS4 - Tmdb Check */
function PS3PS4_TmdbCheck(){
	var def = $.Deferred();
	if($("#tmdb").prop("checked")){
		var key = "F5DE66D2680E255B2DF79E74F890EBF349262F618BCAE2A9ACCDEE5156CE8DF2CDF2D48C71173CDC2594465B87405D197CF1AED3B7E9671EEB56CA6753C2E6B0";
		var msg = title_id + "_00";
		var hmac = GetHmacSha1(key,msg);
		if(title_id.substring(0,2)!="CU" && !tmdb_reject_psp){
			var path = "http://tmdb.np.dl.playstation.net/tmdb/";	//PS3
			var tmdb_xml_url = path + msg + "_" + hmac.toUpperCase() + "/" + msg + ".xml";
			OutputLink(output1,"Tmdb xml",tmdb_xml_url);
			GetPageData(tmdb_xml_url,xml).then(
				function(data){
					if(data!=null){
						def.resolve(data);
					}else{
						def.reject();
					}
				},function(){
					def.reject();
				}
			);
		}else if(title_id.substring(0,2)=="CU"){
			var path = "http://tmdb.np.dl.playstation.net/tmdb2/";	//PS4
			var tmdb2_json_url = path + msg + "_" + hmac.toUpperCase() + "/" + msg + ".json";
			OutputLink(output1,"Tmdb json",tmdb2_json_url);
			GetPageData(tmdb2_json_url,json).then(
				function(data){
					if(data!=null){
						def.resolve(data);
					}else{
						def.reject();
					}
				},function(){
					def.reject();
				}
			);
		}else{
			if(tmdb_reject_psp){
				def.reject();
			}else{
				def.reject();
			}
		}
	}else{
		def.reject();
	}
	return def.promise();
}


/* PS3 - Output of info from the tmdb xml */
function PS3_TmdbOut(data,def){
	console_name = "ps3"
	/* Output of title */
	var temp_titles = [];
	for(var i=0; i<$(data).find("name").length; i++){
		temp_titles.push($($(data).find("name")[i]).text().replace(/\n/," "));
	}
	OutputTmdbUpdateTitle(output2,temp_titles,"tmdb");
	/* Output of icon url */
	var icon_urls = [];
	if($(data).find("icon").length==1){
		icon_urls.push($(data).find("icon").text());
	}else if($(data).find("icon").length>1){
		for(var i=0; i<$(data).find("icon").length; i++){
			icon_urls.push($(data).find("icon")[i].innerHTML);
		}
	}
	if(icon_urls.length!=0){
		var icon_elem_str = GenVideoImgElemStr([],icon_urls);
		OutputDialogLink(output2,"Icon",icon_elem_str);
	}
	/* Output of media type */
	var media_type = $(data).find("media-type").text();
	if(media_type=="disc"){
		OutputItem(output2,"Media Type","BD");
	}else{
		OutputItem(output2,"Media Type","Digital");
	}
	/* Output of parental level */
	if($(data).find("parental-level").length==1){
		OutputItem(output2,"Parental Level",$(data).find("parental-level").text());
	}else{
		var p_lv_all = [];
		for(var i=0; i<$(data).find("parental-level").length; i++){
			var p_lv = $($(data).find("parental-level")[i]).text();
			var region_char = $($(data).find("parental-level")[i]).attr("region");
			var p_lv_and_region = "";
			if(region_char!=undefined){
				p_lv_and_region = p_lv + " (region=" + region_char + ")";
			}else{
				p_lv_and_region = p_lv;
			}
			p_lv_all.push(p_lv_and_region);
		}
		if(p_lv_all.length>0){
			OutputItem(output2,"Parental Level",p_lv_all[0]);
			if(p_lv_all.length>1){
				var p_lv_i = 1;
				var id_name = "tmdb_plv_arrow";
				var plv_show_len = "(<span id='tmdb_plv_deno'>1</span>"+"<span>/"+p_lv_all.length+")</span>";
				var arrow_elem_str = "<span id='"+id_name+"' class='arrow_right'></span>"+plv_show_len;
				output2.find("[name='Parental Level']").find(".item").after(arrow_elem_str);
				$("#"+id_name).on("mouseover",function(){
					$("#"+id_name).css("color","deepskyblue");
				});
				$("#"+id_name).on("mouseout",function(){
					$("#"+id_name).css("color","green");
				});
				$("#"+id_name).on("click",function(){
					output2.find("[name='Parental Level']").find(".item").html(p_lv_all[p_lv_i]);
					$("#tmdb_plv_deno").html((p_lv_i+1));
					p_lv_i++;
					if(p_lv_i>=p_lv_all.length) p_lv_i=0;
				});
			}
		}
	}
	/* Output of resolutin info */
	OutputItem(output2,"Resolution",$(data).find("resolution").text());
	/* Output of sound format info */
	OutputItem(output2,"Sound Format",$(data).find("sound-format").text());
	def.resolve();
}


/* PS4(CUSAYYYYY) - Output of info from the tmdb json */
function PS4_TmdbOut(data,def){
	console_name = "ps4";
	/* Output of title */
	var temp_titles = [];
	for(var i in data.names){
		temp_titles.push(data.names[i].name.replace(/\n/," "));
	}
	OutputTmdbUpdateTitle(output2,temp_titles,"tmdb");
	/* Output of content id and region */
	if(content_id==null){
		content_id = data.contentId;
		OutputItem(output2,"Content ID",content_id);
		CID_RegionCheck(output2);
	}
	/* Output of icon */
	if(data.icons!=undefined){
		var icon_urls = [];
		var icon_names = [];
		for(var i in data.icons){
			icon_urls.push(data.icons[i].icon);
			if(i==0){
				icon_names.push("default");
			}else{
				icon_names.push("lang : " + data.icons[i].lang);
			}
		}
		var icon_elem_str = GenVideoImgElemStr([],icon_urls,icon_names);
		OutputDialogLink(output2,"Icon",icon_elem_str);
	}
	/* Output of parental level */
	OutputItem(output2,"Parental Level",data.parentalLevel);
	/* Output of Play Together */
	var play_together =  data.playTogether;
	if(play_together!=undefined){
		OutputItem(output2,"Play Together",play_together);
	}
	/* Output of info about support for PSVR */
	var psvr = "Yes";
	if(data.psVr==0) psvr = "No";
	OutputItem(output2,"PSVR Support",psvr);
	/* Output of info about support for PS4Pro */
	var ps4pro = "Yes";
	if(data.neoEnable==0) ps4pro = "No";
	OutputItem(output2,"PS4Pro Support",ps4pro);
	/* Output of pronunciation.xml*/
	GetPronunciation(output2,data.pronunciation);
	/* Output of background image */
	if(data.backgroundImage!=undefined){
		var background_img_elem_str = GenVideoImgElemStr([],[data.backgroundImage],["Background Image"]);
		OutputDialogLink(output2,"Background Image",background_img_elem_str);
	}else{
		OutputItem(output2,"Background Image","-");
	}
	/* Output of bgm(at9) url */
	OutputLink(output2,"BGM (at9)",data.bgm);

	def.resolve();
}


/* PSP/PS3 - Update Check */
function PSPPS3_UpdateCheck(def){
	if($("#update").prop("checked")){
		var path = "https://a0.ww.np.dl.playstation.net/tpl/np/";
		var update_xml_url = path + title_id + "/" + title_id + "-ver.xml";
		OutputLink(output1,"Update xml",update_xml_url);
		GetPageData(update_xml_url,xml).then(
			function(data){
				if(data!=null){
					def.resolve(data);
				}else{
					def.reject();
				}
			},function(){
				def.reject();
			}
		);
	}else{
		def.reject();
	}
}


/* PSP/PS3 - Output of info from the update xml */
function PSPPS3_UpdateOut(data,def){
	/* Output of title */
	var title_all = [$(data).find("TITLE")[0]];
	for(var i=0; i<$(data).find("TITLE").nextAll().length; i++){
		title_all.push($(data).find("TITLE").nextAll()[i]);
	}
	var temp_titles = [];
	for(var i=0; i<title_all.length; i++){
		temp_titles.push($(title_all[i]).text().replace(/\n/," "));
	}
	OutputTmdbUpdateTitle(output3,temp_titles,"update");
	/* Output of system version */
	var pkgs = $(data).find("package");
	var console_name2 = "(PSP)";
	console_name = "psp";
	var sys_ver = ($(data).find("package").attr("psp_system_ver"));
	if(sys_ver==undefined){
		sys_ver = $(data).find("package").attr("ps3_system_ver");
		console_name2 = "(PS3)";
		console_name = "ps3";
	}
	var p_len = pkgs.length;
	var l_ver = "";
	if(p_len!=1){
		l_ver = parseFloat($(pkgs[p_len-1]).attr("version")).toFixed(2).toString();
		l_ver = " (v" + l_ver +  ")";
		if(console_name2=="(PSP)"){
			sys_ver = $(pkgs[p_len-1]).attr("psp_system_ver");
		}else{
			sys_ver = $(pkgs[p_len-1]).attr("ps3_system_ver");
		}
	}
	sys_ver = parseFloat(sys_ver).toFixed(2).toString();
	if(isNaN(sys_ver)) sys_ver = "not found";
	if(title_id.substring(0,2)!="NP") console_name2 = "";
	OutputItem(output3,"Required Firmware " + l_ver + console_name2,sys_ver);
	/* Output of pkg url and size */
	for(var i=0; i<p_len; i++){
		var ver = parseFloat($(pkgs[i]).attr("version")).toFixed(2).toString();
		ver =  "v" + ver;
		var update_pkg_url = $(pkgs[i]).attr("url");
		OutputLink(output3,ver + " PKG",update_pkg_url);
		var patch_name = "[name='" + ver + " PKG" + "']";
		var patch_size = " (" + FixSize($(pkgs[i]).attr("size")) + ")";
		output3.find(patch_name).append(patch_size);
		if(content_id==null && i==(p_len-1)){
			/* Output of content id */
			content_id = update_pkg_url.match(content_id_reg)[0];
			OutputItemBefore(output3.find("[name='Required Firmware "+l_ver+console_name2+"']"),"Content ID",content_id);
		}
	}
	/* Output of param.hip url */
	var param_url = $(data).find("paramhip").attr("url");
	if(param_url!=undefined){
		OutputLink(output3,"PARAM.HIP",param_url);
		$("[name='PARAM.HIP'] a").removeAttr("target");
		var param_all = $(data).find("paramhip").nextAll();
		var param_urls = [];
		for(var i=0; i<param_all.length; i++){
			var param_num = param_all[i].tagName.substr(9);
			var param_name = "PARAM_" + param_num + ".HIP";
			param_url = $(param_all[i]).attr("url");
			param_urls.push(param_url);
			param_urls.push(param_name);
		}
		if(param_urls.length>0){
			var param_hrefs = HrefStr(param_urls);
			OutputDialogLink(output3,"PARAM_xx.HIP",param_hrefs);
		}
	}
	def.resolve();
}


/* PSVita(PCSxYYYYY)- Update Check */
function PSVITA_UpdateCheck(){
	var def = $.Deferred();
	if($("#update").prop("checked")){
		var key = "E5E278AA1EE34082A088279C83F9BBC806821C52F2AB5D2B4ABD995450355114";
		var msg = "np_" + title_id;
		var hmac = GetHmacSha256(key,msg);
		var path = "http://gs-sec.ww.np.dl.playstation.net/pl/np/";
		var update_xml_url = path + title_id + "/" + hmac + "/" + title_id + "-ver.xml";
		OutputLink(output1,"Update xml",update_xml_url);
		GetPageData(update_xml_url,xml).then(
			function(data){
				if(data!=null){
					def.resolve(data);
				}else{
					def.reject();
				}
			},function(){
				def.reject();
			}
		);
	}else{
		def.reject();
	}
	return def.promise();
}


/* PSVita(PCSxYYYYY)- Output of info from the update xml */
function PSVITA_UpdateOut(data,def){
	console_name = "vita";
	/* Output of title */
	var title_all = [$(data).find("title")[0]];
	for(var i=0; i<$(data).find("title").nextAll().length; i++){
		title_all.push($(data).find("title").nextAll()[i]);
	}
	var temp_titles = [];
	for(var i=0; i<title_all.length; i++){
		temp_titles.push($(title_all[i]).text().replace(/\n/," "));
	}
	OutputTmdbUpdateTitle(output3,temp_titles,"update");
	/* Output of content id */
	if(content_id==null){
		content_id = $(data).find("package").attr("content_id");
		OutputItem(output3,"Content ID",content_id);
	}
	/* Output of system version */
	var sys_ver = FixSysVer($(data).find("package").attr("psp2_system_ver"));
	var pkgs = $(data).find("package");
	var p_len = pkgs.length;
	var ver = "";
	if(p_len!=1){
		ver = parseFloat($(pkgs[p_len-1]).attr("version")).toFixed(2).toString();
		ver = " (v" + ver +  ")";
		sys_ver = FixSysVer($(pkgs[p_len-1]).attr("psp2_system_ver"));
	}
	OutputItem(output3,"Required Firmware" + ver,sys_ver);
	/* Output of pkg url and size */
	for(var i=0; i<p_len; i++){
		ver = parseFloat($(pkgs[i]).attr("version")).toFixed(2).toString();
		ver = "v" + ver;
		var update_pkg_url = $(pkgs[i]).attr("url");
		OutputLink(output3,ver + " PKG",update_pkg_url);
		var patch_name = "[name='" + ver + " PKG" + "']";
		var patch_size = " (" + FixSize($(pkgs[i]).attr("size")) + ")";
		output3.find(patch_name).append(patch_size);
	}
	/* Output of hybrid pkg url and size */
	var hybrid_pkg = $(data).find("hybrid_package");
	if(hybrid_pkg.length){
		var hybrid_pkg_url = $(hybrid_pkg).attr("url");
		OutputLink(output3,"Hybrid PKG",hybrid_pkg_url);
		var patch_name = "[name='Hybrid PKG']";
		var patch_size = " (" + FixSize($(hybrid_pkg).attr("size")) + ")";
		output3.find(patch_name).append(patch_size);
	}
	/* Output of changeinfo url */
	var changeinfo_url = $(data).find("changeinfo").attr("url");
	if(changeinfo_url!=undefined){
		OutputLink(output3,"ChangeInfo",changeinfo_url);
		var changeinfo_all = $(data).find("changeinfo").nextAll();
		var changeinfo_urls = [];
		for(var i=0; i<changeinfo_all.length; i++){
			var changeinfo_num = changeinfo_all[i].tagName.substr(11);
			var changeinfo_name = "ChangeInfo_" + changeinfo_num;
			changeinfo_url = $(changeinfo_all[i]).attr("url");
			changeinfo_urls.push(changeinfo_url);
			changeinfo_urls.push(changeinfo_name);
		}
		if(changeinfo_urls.length>0){
			OutputDialogLink(output3,"ChangeInfo_xx",HrefStr(changeinfo_urls))
		}
	}
	def.resolve();
}


/* PS4(CUSAYYYYY) - Update Check */
function PS4_UpdateCheck(def){
	if($("#update").prop("checked")){
		var key = "AD62E37F905E06BC19593142281C112CEC0E7EC3E97EFDCAEFCDBAAFA6378D84";
		var msg = "np_" + title_id;
		var hmac = GetHmacSha256(key,msg);
		var path = "http://gs-sec.ww.np.dl.playstation.net/plo/np/";
		var update_xml_url = path + title_id + "/" + hmac + "/" + title_id + "-ver.xml";
		OutputLink(output1,"Update xml",update_xml_url);
		GetPageData(update_xml_url,xml).then(
			function(data){
				if(data!=null){
					def.resolve(data);
				}else{
					def.reject();
				}
			},function(){
				def.reject();
			}
		);
	}else{
		def.reject();
	}
}


/* PS4(CUSAYYYYY) - Output of info from the update xml */
function PS4_UpdateOut(data,def){
	console_name = "ps4";
	/* Output of title */
	var title_all = [$(data).find("title")[0]];
	for(var i=0; i<$(data).find("title").nextAll().length; i++){
		title_all.push($(data).find("title").nextAll()[i]);
	}
	var temp_titles = [];
	for(var i=0; i<title_all.length; i++){
		temp_titles.push($(title_all[i]).text().replace(/\n/," "));
	}
	OutputTmdbUpdateTitle(output3,temp_titles,"update");
	/* Output of content id / Output of region */
	if(content_id==null){
		content_id = $(data).find("package").attr("content_id");
		OutputItem(output3,"Content ID",content_id);
		CID_RegionCheck(output3);
	}
	/* Output of mandatory yes/no */
	var mandatory = "Yes";
	if($(data).find("tag").attr("mandatory")=="false") mandatory = "No";
	OutputItem(output3,"Mandatory Patch",mandatory);
	/* Output of system version */
	var sys_ver = FixSysVer($(data).find("package").attr("system_ver"));
	OutputItem(output3,"Required Firmware",sys_ver);
	/* Output of version */
	var ver = parseFloat($(data).find("package").attr("version")).toFixed(2).toString();
	OutputItem(output3,"Patch Version",ver);
	/* Output of pkg size */
	OutputItem(output3,"Total Size",FixSize($(data).find("package").attr("size")));
	/* Output of pkg manifest url */
	var pkg_mf_url = $(data).find("package").attr("manifest_url");
	OutputLink(output3,"PKG Manifest",pkg_mf_url);
	/* Output of the number of pieces and url of each piece */
	GetPageData(pkg_mf_url,json).then(
		function(data2){
			if(data2!=null && data2!=undefined){
				var piece = data2.pieces;
				var piece_num = piece.length;
				OutputItem(output3,"Number of Pieces",piece_num);
				for(var i=0; i<piece_num; i++){
					var piece_url = piece[i].url;
					OutputLink(output3,"PKG (Piece" + (i+1) + ")",piece_url);
				}
				/* Output of delta pkg url */
				var delta_pkg_url = $(data).find("delta_info_set").attr("url");
				OutputLink(output3,"Delta PKG",delta_pkg_url);
				/* Output of changeinfo url */
				var changeinfo_url = $(data).find("changeinfo").attr("url");
				if(changeinfo_url!=undefined){
					OutputLink(output3,"ChangeInfo",changeinfo_url);
					var changeinfo_all = $(data).find("changeinfo").nextAll();
					var changeinfo_urls = [];
					for(var i=0; i<changeinfo_all.length; i++){
						var changeinfo_num = changeinfo_all[i].tagName.substr(11);
						var changeinfo_name = "ChangeInfo_" + changeinfo_num;
						changeinfo_url = $(changeinfo_all[i]).attr("url");
						changeinfo_urls.push(changeinfo_url);
						changeinfo_urls.push(changeinfo_name);
					}
					if(changeinfo_urls.length>0){
						OutputDialogLink(output3,"ChangeInfo_xx",HrefStr(changeinfo_urls))
					}
				}
				/* Output of playgo manifest url */
				var playgo_mf_url = $(data).find("latest_playgo_manifest").attr("url");
				OutputLink(output3,"PlayGo Manifest",playgo_mf_url);
			}
		}
	);
	def.resolve();
}


/* Chihiro-api url Check */
function ChihiroCheck(re_check){
	InputDisable();
	if(re_check!=undefined && re_check){
		valkyrie_hit = 0;
		search_titles = [];
	}
	if(title_id.match(/^CUSA/)!=null && store_product_url==null && titlecontainer_reject==false){
		var ps4_titlecontainer_flag = true;
	}else{
		var ps4_titlecontainer_flag = false;
	}
	if($("#chihiro").prop("checked") && (content_id!=null || ps4_titlecontainer_flag)){
		var chihiro_s = $("#selectbox").val();
		if(chihiro_s=="default"){
			if(store_product_url!=null){
				try{
					chihiro_r2 = store_product_url.match(/[a-zA-Z]{2}-([a-zA-Z]{4}-)?[a-zA-Z]{2}/)[0];
					var lang = chihiro_r2.substring(0,chihiro_r2.match(/-[a-zA-Z]{2}$/)["index"]);
					chihiro_r2 = chihiro_r2.match(/-.{2}$/)[0].replace(/-/,"");
					if(lang.indexOf("zh-hant")==0){
						lang = "ch";
					}else if(lang.indexOf("zh-hans")==0){
						lang = "zh";
					}
					chihiro_r2 = chihiro_r2 + "/" + lang;
				}catch(e){
					if(chihiro_r==null) chihiro_r2 = "US";
					FuzzyRegionLang();
				}
			}else{
				if(chihiro_r==null) chihiro_r2 = "US";
				FuzzyRegionLang();
			}
		}else{
			chihiro_r2 = chihiro_s;
		}
		if(ps4_titlecontainer_flag){
			var path = "https://store.playstation.com/store/api/chihiro/00_09_000/titlecontainer/";
			var chihiro_json_url = path + chihiro_r2 + "/999/" + title_id + "_00";
		}else{
			var path = "https://store.playstation.com/store/api/chihiro/00_09_000/container/";
			var chihiro_json_url = path + chihiro_r2 + "/999/" + content_id;
		}
		var item_name = "Chihiro json";
		if(valkyrie_hit==1 && $(".chihiro").length==1){
			item_name = "Chihiro json2";
		}

		OutputLink(output1,item_name,chihiro_json_url);
		output1.find("[name='"+item_name+"']").append(" ("+chihiro_r2+")");
		GetPageData(chihiro_json_url,json).then(
			function(data){
				if(data!=null){
					ChihiroOut(data,chihiro_json_url);
				}else{
					output1.find("[name='"+item_name+"']").append(notfound);
					if(valkyrie_hit==0 && titles.length!=0){
						search_index = 0;
						search_titles_len = 0;
						ValkyrieCheck1();
					}else{
						InputEnable();
					}
				}
			},function(){
				output1.find("[name='"+item_name+"']").append(notfound);
				if(valkyrie_hit==0 && titles.length!=0){
					ValkyrieCheck1();
					search_index = 0;
					search_titles_len = 0;
				}else{
					InputEnable();
				}
			}
		);
	}else if($("#chihiro").prop("checked")){
		if(valkyrie_hit==0 && titles.length!=0 && console_name=="ps3" && chihiro_r!=null){
			FuzzyRegionLang();
			search_index = 0;
			search_titles_len = 0;
			ValkyrieCheck1();
		}else{
			var notice = "Content ID is null.<br>Chihiro Check isn't executed.";
			OutputNotice(output4,notice);
			InputEnable();
		}
	}else{
		InputEnable();
	}
}

function FuzzyRegionLang(){
	switch(chihiro_r){
		case "EU": chihiro_r2 = "gb/en"; break;
		case "US": chihiro_r2 = "us/en"; break;
		case "JP": chihiro_r2 = "jp/ja"; break;
		case "HK": chihiro_r2 = "hk/zh"; break;
		case "KR": chihiro_r2 = "kr/ko"; break;
		case "ASIA": chihiro_r2 = "hk/en"; break;
		default : chihiro_r2 = "us/en"; break;
	}
}

/* Output of info from the chihiro json */
function ChihiroOut(data,chihiro_json_url){
	output4.empty();
	if(!video_flag){
		/* Output of title */
		OutputItem(output4,"Title",data.name);
		/* Output of title id */
		var title_id2 = data.id.match(title_id_reg)[0];
		if(title_id!=title_id2 || valkyrie_hit==1){
			OutputItem(output4,"Title ID",title_id2);
		}
		/* Output of content id */
		var content_id2 = data.id;
		if(content_id!=content_id2 || valkyrie_hit==1){
			OutputItem(output4,"Content ID",content_id2);
		}
		/* Output product url */
		var chihiro_r_a = chihiro_r2.split("/");
		var country = chihiro_r_a[0];
		var lang = chihiro_r_a[1];
		if(lang=="ch"){
			lang = "zh-hant";
		}else if(lang=="zh"){
			lang = "zh-hans";
		}
		var path = "https://store.playstation.com/";
		var store_product_url2 = path + lang + "-" + country + "/product/" + data.id;
		OutputLink(output4,"Product",store_product_url2);
		/* Output of image */
		var img_urls = [];
		var img_names = [];
		if(data.images!=undefined && data.images.length>0){
			for(var i in data.images){
				img_urls.push(data.images[i].url);
				var img_name = "Type : " + data.images[i].type;
				img_names.push(img_name);
			}
			var img_elem_str = GenVideoImgElemStr([],img_urls.reverse(),img_names.reverse());
			OutputDialogLink(output4,"Product Images",img_elem_str);
		}
		/* Output of publisher */
		OutputItem(output4,"Publisher",data.provider_name);
		/* Output of release date */
		var release_date = new Date(data.release_date).toLocaleDateString();
		if(release_date!="Invalid Date"){
			OutputItem(output4,"Release Date",release_date);
		}
		/* output of content rating */
		var content_rating = data.content_rating.description;
		if(content_rating!=undefined){
			OutputItem(output4,"Content Rating",content_rating);
		}
		/* Output of content type */
		OutputItem(output4,"Content Type",data.game_contentType);
		/* Output of default_sku info */
		var size_out = false;
		if(data.default_sku!=undefined){
			/* Output of eligibilities */
			var eligibilities = data.default_sku.eligibilities;
			if(eligibilities.length>0){
				GetEligibilities(output4,eligibilities,data.name);
			}
			/* Output of entitlements */
			var entitlements = data.default_sku.entitlements;
			if(entitlements.length>1){
				GetEntitlements(output4,entitlements);
			}
			/* Output of price and rewards */
			var price = data.default_sku.display_price;
			OutputItem(output4,"Price",price);
			var rewards = data.default_sku.rewards;
			if(rewards.length>0){
				GetRewards(output4,rewards);
			}
			/* Output of size */
			var size = 0;
			try{
				for(var i in entitlements){
					if(entitlements[i].drms!=undefined && entitlements[i].drms.length>0){
						size = size + entitlements[i].drms[0].size;
					}
					if(entitlements[i].packages!=undefined && entitlements[i].packages.length>0){
						size = size + entitlements[i].packages[0].size;
					}
				}
				if(size>0) OutputItem(output4,"Content Size",FixSize(size));
			}catch(e){console.log(e)}
		}else{
			//OutputItem(output4,"Price","-");
			//OutputItem(output4,"Content Size","-");
		}
		/* Output videos/screenshots */
		var video_img_elem_str="", video_exist=false, img_exist=false;
		var mediaList = data.mediaList;
		if(mediaList!=undefined){
			video_img_elem_str = GetVideoImg_mediaList(mediaList);
		}else{
			var promo = data.promomedia;
			if(promo.length!=0){
				video_img_elem_str = GetVideoImg_promomedia(promo);
			}
		}
		if(video_img_elem_str!=""){
			if(video_img_elem_str.indexOf("</video>")>-1){
				video_exist = true;
			}
			if(video_img_elem_str.indexOf("<img src=")>-1){
				img_exist = true;
			}
			var item_name = "";
			if(video_exist && img_exist){
				item_name = "Video/Screenshot";
			}else if(video_exist){
				item_name = "Video";
			}else if(img_exist){
				item_name = "Screenshot";
			}
			if(item_name!=""){
				OutputDialogLink(output4,item_name,video_img_elem_str)
			}
		}
		/* Output of description */
		if(data.long_desc!=undefined){
			OutputDialogLink(output4,"Description",data.long_desc);
		}
		/* Output of star rating */
		var star = data.star_rating;
		if(star.total!=null){
			OutputItem(output4,"Total Star",star.total);
			OutputItem(output4,"Average",star.score);
			for(var i in star.count){
				var star_n = 5 - i;
				var star_c = 4 - i;
				OutputItem(output4,star_n + "-Star",star.count[star_c].count);
			}
		}
		/* Output of relationships */
		var relation = data.relationships
		if(relation!=undefined){
			for(var i in relation){
				var relation_url = store_product_url2 + "/1?relationship=" + relation[i].key_name
				relation_url = relation_url.replace(/\/product\//,"/grid/");
				var count = " (" + relation[i].count + ")";
				OutputLink(output4,relation[i].name + count, relation_url)
			}
		}
		/* Output of parent content info */
		if(data.parent_links!=undefined && data.parent_links.length>0){
			var parent_links = data.parent_links;
			/* Output of parent name */
			if(parent_links[0].name!=undefined && parent_links[0].name.length>0){
				var parent_name = parent_links[0].name;
				OutputItem(output4,"Parent Title",parent_name);
			}else if(parent_links[0].short_name!=undefined && parent_links[0].short_name.length>0){
				var parent_name = parent_links[0].short_name;
				OutputItem(output4,"Parent Title",parent_name);				
			}
			/* Output of parent url */
			if(parent_links[0].id!=undefined){
				var parent_url = path + lang + "-" + country + "/product/" + parent_links[0].id;
				OutputLink(output4,"Parent Product",parent_url);
			}
		}
		InputEnable();
	}else{
		ChihiroOut_Video(data,chihiro_json_url)
	}
}

/* Output of info from the chihiro json (PS Video) */
function ChihiroOut_Video(data,chihiro_json_url){
	/* Output of title */
	var sub_cat = data.sub_category;
	if(sub_cat=="series"){
		OutputItem(output4,"Series",data.series_name);
	}else if(sub_cat=="season"){
		if(data.parent_name!=undefined){
			OutputItem(output4,"Title",data.parent_name);
		}else if(data.series_name!=undefined){
			OutputItem(output4,"Title",data.series_name);
		}else{
			OutputItem(output4,"Title",data.title_name);
		}
	}else if(sub_cat=="episode"){
		OutputItem(output4,"Title",data.series_name);
		var ep_num = data.episode_number;
		OutputItem(output4,"Episode "+ep_num,data.name);
	}else if(data.top_category=="film"){
		OutputItem(output4,"Title",data.title_name);
	}
	/* Output product url */
	var chihiro_r_a = chihiro_r2.split("/");
	var country = chihiro_r_a[0];
	var lang = chihiro_r_a[1];
	if(lang=="ch"){
		lang = "zh-hant";
	}else if(lang=="zh"){
		lang = "zh-hans";
	}
	var path = "https://store.playstation.com/";
	var store_product_url2 = path + lang + "-" + country + "/product/" + data.id;
	OutputLink(output4,"Product",store_product_url2);
	/* Output of image */
	var img_urls = [];
	var img_names = [];
	if(data.images!=undefined && data.images.length>0){
		for(var i in data.images){
			img_urls.push(data.images[i].url);
			var img_name = "Type : " + data.images[i].type;
			img_names.push(img_name);
		}
		var img_elem_str = GenVideoImgElemStr([],img_urls.reverse(),img_names.reverse());
		OutputDialogLink(output4,"Product Images",img_elem_str);
	}
	/* Output of publisher */
	OutputItem(output4,"Publisher",data.provider_name);
	/* Output of release date */
	var release_date = new Date(data.release_date).toLocaleDateString();
	if(release_date!="Invalid Date"){
		OutputItem(output4,"Release Date",release_date);
	}
	/* Output of meta data */
	var meta = data.metadata;
	if(meta!=undefined){
		try{
			var copyright = meta.copyright_notice;
			if(copyright!=undefined){
				OutputItem(output4,copyright.name,copyright.values.toString());
			}
			if(meta.genre!=undefined){
				OutputItem(output4,meta.genre.name,meta.genre.values.toString());
			}
			if(meta.display_studio!=undefined){
				OutputItem(output4,meta.display_studio.name,meta.display_studio.values.toString());
			}
		}catch(e){console.log(e)}
	}
	/* Output of price */
	if(data.default_sku!=undefined && data.default_sku.display_price!=undefined){
		OutputItem(output4,"Price",data.default_sku.display_price);
		if(data.skus!=undefined && data.skus[0].rewards!=undefined && data.skus[0].rewards.length>0){
			GetRewards(output4,data.skus[0].rewards);
		}
	}
	/* Output of description */
	OutputDialogLink(output4,"Description",data.long_desc);
	/* Output of episode list */
	var links = data.links;
	if(sub_cat=="season" && data.attributes.facets.sub_category[0].key=="episode"){
		var epi_elem = [];
		for(var i in links){
			var epi_str = "Episode " + links[i].episode_number + " : ";
			epi_str = epi_str + links[i].name + "<br>";
			var link_elem = "<a href='' class='epi_chihiro'>"+links[i].id+"</a>"
			epi_str+= "Content ID : " + link_elem;
			epi_str = "<li>" + epi_str + "</li>";
			epi_elem.push(epi_str);
		}
		if(epi_elem.length>0){
			OutputDialogLink(output4,"Episode List","<ul>"+epi_elem.join("")+"</ul>")
			$(".epi_chihiro").on("click",function(){
				$("#input_key").val($(this).text());
				content_id = $(this).text();
				$("#EpisodeList_dialog").dialog("close");
				ReChihiroCheck();
				return false;
			});
		}
	}
	/* Output of star rating */
	var star = data.star_rating;
	if(star.total!=null){
		OutputItem(output4,"Total Star",star.total);
		OutputItem(output4,"Average",star.score);
		for(var i in star.count){
			var star_n = 5 - i;
			var star_c = 4 - i;
			OutputItem(output4,star_n + "-Star",star.count[star_c].count);
		}
	}
	/* Output of season chihiro check link */
	var p_links = data.parent_links;
	if(sub_cat=="episode" && p_links!=undefined && p_links.length>0){
		if(p_links[0].sub_category=="season"){
			OutputLink(output4,"Get the season's Chihiro","");
			var name_attr = "[name='Get the seasons Chihiro'] a";
			$(name_attr).removeAttr("target");
			$(name_attr).on("click",function(){
				$("#input_key").val(p_links[0].id);
				content_id = p_links[0].id;
				ReChihiroCheck();
				return false;
			});
		}
	}
	if(sub_cat=="series" && links!=undefined && links.length>0){
		if(links[0].sub_category=="season"){
			OutputLink(output4,"Get the season's Chihiro","");
			var name_attr = "[name='Get the seasons Chihiro'] a";
			$(name_attr).removeAttr("target");
			$(name_attr).on("click",function(){
				$("#input_key").val(links[0].id);
				content_id = links[0].id;
				ReChihiroCheck();
				return false;
			});
		}
	}
	InputEnable();
}


function ValkyrieCheck1(){
	if(titles.length!=0 && console_name!=null){
		console.log("### valkyrie check started ("+(search_index+1)+") ###");
		if(search_index==0){
			chihiro_r2 = chihiro_r2.split("/")[1] +"/"+ chihiro_r2.split("/")[0];
		}
		var path = "https://store.playstation.com/valkyrie-api/" + chihiro_r2 + "/999/tumbler-search/"
		/* Set check words */
		if(search_titles_len==0){
			var search_strs = [" ","　","(","（","\n","?","？","!","！",".","・","™","®","Ⓡ","'","-","－",":","/","\\","。","★","☆"];
			for(var i in titles){
				search_titles_len++;
				var search_indexes = [];
				for(var x in search_strs){
					var title_i = titles[i].indexOf(search_strs[x]);
					if(title_i>0){
						search_indexes.push(title_i);
					}
				}
				var min_i = titles[i].length;
				if(search_indexes.length>0){
					min_i = Math.min.apply(null, search_indexes);
				}
				search_titles[i] = [];
				search_titles[i][0] = titles[i];
				search_titles[i][1] = titles[i].slice(0,min_i);
			}
			var result = {};
			var result_index = 0;
			var result_len = 0;
			for(var i=0; i<search_titles_len; i++){
				for(var x=0; x<search_titles_len; x++){
					var title_match = search_titles[x][1]==search_titles[i][1];
					if(title_match && x!=i){
						x = search_titles_len;
					}else if(title_match && x==i){
						result[result_index] = [];
						result[result_index][0] = search_titles[i][0];
						result[result_index][1] = search_titles[i][1];
						result_index++; result_len++;
						x = search_titles_len;
					}
				}
			}
			search_titles = result;
			search_titles_len = result_len;
		}
		/* Start check */
		console.log("title : " + search_titles[search_index][0] + "\nsearch : " + search_titles[search_index][1] + "\noriginal title id : " + title_id + "\noriginal content id : " + content_id + "\nvalkyrie language/country : " + chihiro_r2);
		var search_key = encodeURI(search_titles[search_index][1]);
		var platform_key = "&platform=" + console_name;
		var valkyrie_search_url = path + search_key + "?suggested_size=99999" + platform_key;
		GetPageData(encodeURIComponent(valkyrie_search_url),json).then(
			function(data){
				if(data!=null){
					ValkyrieCheck2(data,valkyrie_search_url);
				}else{
					console.log("### valkyrie check failed ###");
					var notice = "Valkyrie Check failed :(";
					OutputNotice(output4,notice);
					InputEnable();
				}
			},function(){
				console.log("### valkyrie check failed ###");
				var notice = "Valkyrie Check failed :(";
				OutputNotice(output4,notice);
				InputEnable();
			}
		);
	}else{
		InputEnable();
	}
}

function ValkyrieCheck2(data,valkyrie_search_url,orig_title){
	output4.empty();
	var total_suggested = data.data.attributes.total_suggested;
	console.log("total_suggested : " + total_suggested +" \n"+ valkyrie_search_url);
	if(total_suggested>0){
		if($(".valkyrie").length){
			OutputLink(output1,"Valkyrie json"+(search_index+1),valkyrie_search_url);
		}else{
			OutputLink(output1,"Valkyrie json",valkyrie_search_url);
		}
		/* Check if title id matches */
		var children = data.data.relationships.children.data;
		for(var i=0; i<children.length; i++){
			var content_id2 = children[i].id;
			var title_id2 = content_id2.match(title_id_reg)[0];
			if(title_id==title_id2){
				/*	"tumblr-search" probably only search for games.
					So even if the type is "game-related", probably no problem.
					(PSP and PS3 disc-only games are probably treated as "game-related") */
				console.log("title id matched");
				content_id = content_id2;
				valkyrie_hit = 1;
				i = children.length;
			}
		}
		/* Check if titles match exactly */
		if(valkyrie_hit==0 && data.included!=undefined){
			for(var i=0; i<data.included.length; i++){
				var inc = data.included[i];
				var inc_attr = inc.attributes;
				if(inc_attr.name!=undefined && inc_attr.name==search_titles[search_index][0]){
					console.log("title name matched");
					content_id = inc.id;
					valkyrie_hit = 1;
					i = data.included.length;
				}
			}
		}
		/* Check if the last 16 characters of the content id matches */
		if(valkyrie_hit==0 && content_id!=null){
			for(var i=0; i<children.length; i++){
				var content_id2 = children[i].id;
				var final_str1 = content_id.substr(20,16);
				var final_str2 = content_id2.substr(20,16);
				if(final_str1==final_str2){
					console.log("content id matched");
					content_id = content_id2;
					valkyrie_hit = 1;
					i = children.length;
				}
			}
		}
		if(valkyrie_hit==1){
			console.log("content id is found : " + content_id + " \n### valkyrie check finished ("+(search_index+1)+") ###");
			ChihiroCheck();
		}else{
			console.log("content id is not found. \n### valkyrie check finished ("+(search_index+1)+") ###");
			if((search_index+1)<search_titles_len){
				search_index++;
				ValkyrieCheck1();
			}else{
				var notice = "Valkyrie Check finished.<br>Content ID for this title is not found.";
				OutputNotice(output4,notice);
				InputEnable();
			}
		}
	}else{
		console.log("content id is not found. \n### valkyrie check finished ("+(search_index+1)+") ###");
		if((search_index+1)<search_titles_len){
			search_index++;
			ValkyrieCheck1();
		}else{
			var notice = "Valkyrie Check finished.<br>Content ID for this title is not found.";
			OutputNotice(output4,notice);
			InputEnable();
		}
	}
}

/* HMAC-SHA1 */
function GetHmacSha1(key,msg){
	var shaObj = new jsSHA("SHA-1", "TEXT");
	shaObj.setHMACKey(key, "HEX");
	shaObj.update(msg);
	var hmac = shaObj.getHMAC("HEX");
	return hmac.toUpperCase();
}

/* HMAC-SHA256 */
function GetHmacSha256(key,msg){
	var shaObj = new jsSHA("SHA-256", "TEXT");
	shaObj.setHMACKey(key, "HEX");
	shaObj.update(msg);
	var hmac = shaObj.getHMAC("HEX");
	return hmac;
}

/* (For PSVita/PS4) */
function FixSysVer(sys_ver){
	sys_ver = (parseFloat(sys_ver).toString(16)/1000000).toFixed(3);
	sys_ver = sys_ver.slice(0,4);
	return sys_ver;
}

function FixSize(size){
	var unit_array = ["Byte","KB","MB","GB","TB"];
	var unit_i = 0;
	for(size; size>=1024; size=Math.floor((size/1024)*10)/10){
		unit_i++;
	}
	return size.toString() + unit_array[unit_i];
}

function OutputItem(out,item_name,str){
	out.append(ElemStr(item_name,str));
}

function OutputItemAfter(out,item_name,str){
	out.after(ElemStr(item_name,str));
}

function OutputItemBefore(out,item_name,str){
	out.before(ElemStr(item_name,str));
}

function OutputItemPrepend(out,item_name,str){
	out.prepend(ElemStr(item_name,str));
}

/* Processing of title name string of TMDB */
function OutputTmdbUpdateTitle(out,temp_titles,id_str){
	var out_titles = [];
	for(var i=0; i<temp_titles.length; i++){
		var title_temp = temp_titles[i];
		if(out_titles.indexOf(title_temp)==-1){
			out_titles.push(title_temp);
		}
		if(titles.indexOf(title_temp)==-1){
			titles.push(title_temp);
		}
	}
	OutputItemPrepend(out,"Title",out_titles[0]);
	if(out_titles.length>1){
		var x = 1;
		var id_name = id_str + "_title_arrow";
		var deno = id_str + "_deno";
		var title_show_len = "(<span id='"+deno+"'>1</span>"+"<span>/"+out_titles.length+")</span>";
		var arrow_elem_str = "<span id='"+id_name+"' class='arrow_right'></span>"+title_show_len;
		out.find("[name='Title']").find(".item").after(arrow_elem_str);
		$("#"+id_name).on("mouseover",function(){
			$("#"+id_name).css("color","deepskyblue");
		});
		$("#"+id_name).on("mouseout",function(){
			$("#"+id_name).css("color","green");
		});
		$("#"+id_name).on("click",function(){
			out.find("[name='Title']").find(".item").html(out_titles[x]);
			$("#"+deno).html((x+1));
			x++;
			if(x>=out_titles.length) x=0;
		});
	}
}

function ElemStr(item_name,str){
	if(str==undefined) str="?";
	str = str.toString();
	var item = "<span class='item'>" + str + "</span>";
	item = "<span class='item_name'>" + item_name + " : </span>" + item;
	item_name = item_name.replace(/\//,"-");
	item_name = item_name.replace(/\'/,"");
	var item_class = "";
	if(item_name.indexOf("Chihiro json")>-1){
		item_class = "class='chihiro'"
	}else if(item_name.indexOf("Valkyrie json")>-1){
		item_class = "class='valkyrie'"
	}else if(item_name.indexOf("Update xml")>-1){
		item_class = "class='update'"
	}else if(item_name.indexOf("Tmdb xml")>-1 || item_name.indexOf("Tmdb json")>-1){
		item_class = "class='tmdb'"
	}
	var elem = "<li name='"+item_name+"' "+item_class+" >" + item + "</li>";
	return elem;
}

function OutputLink(out,item_name,url){
	if(url!=undefined){
		var href = " href='" + url + "'";
		var target = " target='_blank'";
		var link_elm = "<a" + href + target + ">Click here</a>";
	}else{
		var link_elm = "-";
	}
	out.append(ElemStr(item_name,link_elm));
}

function OutputNotice(out,str){
	out.append("<li class='notice'>" + str + "</li>");
}

function OutputDialogLink(out,item_name,str){
	var dialog_id = item_name.replace(/( |\/|\.)/g,"") + "_dialog";
	str = "<div class='dialog_inner'>" + str + "</div>";
	var elem = "<div class='dialog' title='"+item_name+"' id='"+dialog_id+"'>"+str+"</div>"
	out.append(elem);
	$("#"+dialog_id).find("font").attr("color","darkblue");
	OutputLink(out,item_name,"");
	var link_name_attr = "[name='" + item_name + "'] a";
	link_name_attr = link_name_attr.replace(/\//,"-");
	$(link_name_attr).removeAttr("target");
	$(link_name_attr).on("click",function(){
		$("#"+dialog_id).dialog({
			modal:true,
			maxHeight:600,
			width: "auto",
			position: {
				my: "center top",
				at: "center top+15%",
			},
			create: function(event,ui){
				/* Adjust the css of the dialog */
				var ua = window.navigator.userAgent.toLowerCase();
				$(this).css("padding","0.5em 0");
				$(".dialog").css("margin-left","1em");
				if(ua.indexOf("edge")!=-1){
					$(".dialog_inner").css("margin-right","2.3em");
				}else if(ua.indexOf("chrome")!=-1){
					$(".dialog_inner").css("margin-right","1.2em");
				}else{
					$(".dialog_inner").css("margin-right","2.3em");
				}
				if($("#"+dialog_id).find(".lazy").attr("src")==undefined){
					/* description dialog */
					$(".ui-dialog").css("background","#f9f9f9");
				}else{
					/* image dialog */
					$(".ui-dialog").css("background","gray");
					$(".ui-dialog-content").css("overflow-x","hidden");
				}
			},
			open: function(){
				$("body").css("overflow", "hidden");
				$("#"+dialog_id+" .lazy").lazyload();
				/* Adjust the position of the dialog when using lazyload */
				var position_change = function(){
					var attr_src = $("#"+dialog_id).find(".lazy").attr("src");
					if(attr_src!=undefined && attr_src!="js/gray530.jpg"){
						if(!$("#"+dialog_id).hasClass("position_changed")){
							var dialog_position = ($(window).width()-$(".ui-dialog").width())/2;
							$(".ui-dialog").css("left",dialog_position);
							$("#"+dialog_id).addClass("position_changed");
							clearInterval(position_change_interval);
							clearTimeout(interval_clear_timeout);
						}else{
							clearInterval(position_change_interval);
							clearTimeout(interval_clear_timeout);
						}
					}else{
						if(attr_src==undefined){
							clearInterval(position_change_interval);
							clearTimeout(interval_clear_timeout);
						}
					}
				}
				var position_change_interval = setInterval(position_change,100);
				var interval_clear_timeout = setTimeout(function(){
					clearInterval(position_change_interval);
				},6000);
				/* Sort Product Images by size (move type1 before type9) */
				if(dialog_id=="ProductImages_dialog"){
					var t1,t9;
					var pic_elems = $("#"+dialog_id).find(".pic");
					var pic_name = pic_elems.find(".pic_name");
					for(var i=0; i<pic_elems.length; i++){
						if($(pic_name[i]).text()=="Type : 9"){
							t9=i;
						}else if($(pic_name[i]).text()=="Type : 1"){
							t1=i;
						}
					}
					if(t1!=undefined && t9!=undefined){
						var img_origin = $(pic_elems[t1]).find(".lazy").attr("data-original");
						$(pic_elems[t1]).find(".lazy").attr("src",img_origin)
						$(pic_elems[t1]).remove();
						$(pic_elems[t9]).before("<div class='pic'>"+$(pic_elems[t1]).html()+"</div>")
					}
				}
			},
			close: function(){
				$("body").css("overflow", "auto");
				/* delete dialog cache */
				$(".ui-dialog").remove();
			}
		});
		var lazy_count = 0;
		$("#"+dialog_id).on("scroll", function(e){
			if(lazy_count<30){
				$("#"+dialog_id+" .lazy").lazyload();
				lazy_count++;
			}
		});
		/* Click outside the dialog to close the dialog and stop the video */
		$(document).on('click',function(e){
			if(!$(e.target).closest("#"+dialog_id).length){
				if($("#"+dialog_id).hasClass("ui-dialog-content")){
					$("#"+dialog_id).dialog("close");
				}
				for(var i=0; i<$("video").length; i++){
					$("video").get(i).pause();
				}
			}else{}
		});
		return false;
	});
}

function OutputAlertLink(out,item_name,str){
	OutputLink(out,item_name,"");
	var link_name_attr = "[name='" + item_name + "'] a";
	$(link_name_attr).removeAttr("target");
	$(link_name_attr).on("click",function(){
		alert(str);
		return false;
	});
}

/* (PS4 TMDB) */
function GetPronunciation(out,pron_xml){
	GetPageData(pron_xml,xml).then(
		function(data){
			if(data!=null){
				var langs = $(data).find("language");
				var pron_elems = [];
				for(var i=0; i<langs.length; i++){
					var lang_id = $(langs[i]).attr("id");
					var words = $(langs[i]).find("speechRecognitionWords");
					var word_elems = [];
					for(var x=0; x<words.length; x++){
						var word_str = "Text : " + $(words[x]).find("text").text() + "<br>";
						word_str += "Pron : " + $(words[x]).find("pronunciation").text() + "<br>";
						word_elems.push(word_str);
					}
					var pron_str = "Language ID : " + lang_id + "<br>";
					pron_str += word_elems.join("");
					pron_str = "<li>" + pron_str + "</li>";
					pron_elems.push(pron_str);
				}
				if(pron_elems.length>0){
					var pron_str = "<ul>"+pron_elems.join("")+"</ul>";
					var pron_link = "<a href='"+pron_xml+"'>Pronunciation xml</a>";
					pron_str = pron_link + pron_str;
					OutputDialogLink(out,"Pronunciation",pron_str);
					$("[name='Pronunciation']").insertAfter("[name='PS4Pro Support']")[0];
				}
			}
		}
	);
}

/* (Chihiro) */
function GetEligibilities(out,eligibilities,product_title){
	var eli_elems = [];
	for(var i in eligibilities){
		if(product_title.indexOf(eligibilities[i].name)<0 && eligibilities[i].id!=content_id){
			var eli_str = "Title : " + eligibilities[i].name + "<br>";
			var eli_id = eligibilities[i].id;
			eli_str += "ID : " + eli_id + "<br>";
			eli_str+= "Operator (It means 'Currently Required'?) : " + eligibilities[i].operator + "<br>";
			eli_str = "<li>" + eli_str + "</li>";
			eli_elems.push(eli_str);
		}
	}
	if(eli_elems.length>0){
		OutputDialogLink(out,"Eligibilities","<ul>"+eli_elems.join("")+"</ul>")
		$(".eligibility").on("click",function(){
			$("#input_key").val($(this).text());
			content_id = $(this).text();
			$("#Eligibilities_dialog").dialog("close");
			ReChihiroCheck();
			return false;
		});
	}
}

/* (Chihiro) */
function GetEntitlements(out,entitlements){
	var en_elems = [];
	for(var i in entitlements){
		var en_str = "Title : " + entitlements[i].name + "<br>";
		var en_id = entitlements[i].id;
		en_str += "ID : " + en_id + "<br>";
		var size = 0;
		if(entitlements[i].drms!=undefined && entitlements[i].drms.length>0){
			for(var x in entitlements[i].drms){
				size += entitlements[i].drms[x].size;
			}
		}
		if(entitlements[i].packages!=undefined && entitlements[i].packages.length>0){
			for(var y in entitlements[i].packages){
				size += entitlements[i].packages[y].size;
			}
		}
		if(size>0){
			en_str += "Size : " + FixSize(size) + "<br>";
		}
		en_str = "<li>" + en_str + "</li>";
		en_elems.push(en_str);
	}
	if(en_elems.length>0){
		OutputDialogLink(out,"Entitlements","<ul>"+en_elems.join("")+"</ul>");
		$(".entitlement").on("click",function(){
			$("#input_key").val($(this).text());
			content_id = $(this).text();
			$("#Entitlements_dialog").dialog("close");
			ReChihiroCheck();
			return false;
		});
	}
}

/* (Chihiro) */
function GetRewards(out,rewards){
	var reward_elems = [];
	for(var i in rewards){
		var reward_str = "Reward ID : " + rewards[i].id + "<br>";
		if(rewards[i].entitlement_id!=undefined){
			reward_str += "Entitlement ID : " + rewards[i].entitlement_id + "<br>";
		}
		if(rewards[i].isPlus){
			reward_str += "for PS Plus members : Yes<br>";
		}else if(rewards[i].isEAAccess){
			reward_str += "for EA Access members : Yes<br>";
		}
		var save = "";
		if(rewards[i].discount!=0){
			save = " (SAVE " + rewards[i].discount + "%)";
		}
		var price = rewards[i].display_price;
		reward_str += "Price : " + price + save + "<br>"
		var end_date = new Date(rewards[i].end_date).toLocaleDateString();
		if(end_date!="Invalid Date"){
			reward_str += "Discount/Reward Period : " + end_date + "<br>";
		}
		reward_str = "<li>" + reward_str + "</li>";
		reward_elems.push(reward_str);
	}
	if(reward_elems.length>0){
		OutputDialogLink(out,"Discount/Reward","<ul>"+reward_elems.join("")+"</ul>");
	}

}

/* (Chihiro) */
function GetVideoImg_mediaList(mediaList){
	var mp4_urls = [], pic_urls =[];
	var previews = mediaList.previews;
	for(var i in previews){
		mp4_urls.push(previews[i].url);
	}
	var screenshots = mediaList.screenshots;
	for(var i in screenshots){
		pic_urls.push(screenshots[i].url);
	}
	var elem_str = GenVideoImgElemStr(mp4_urls,pic_urls);
	return elem_str;
}

/* (Chihiro) */
function GetVideoImg_promomedia(promo){
	var materials = [];
	for(var i=0; i<promo.length; i++){
		var vita_promo_check = null;
		if(promo[i].key=="space"){
			if(i==0 && promo[0].materials!=undefined && promo[0].materials.length){
				vita_promo_check = promo[0].materials.length;
			}
			for(var x in promo[i].materials){
				if(promo[i].materials[x].urls!=undefined){
					materials.push(promo[i].materials[x].urls[0].url);
				}
			}
		}
		if(promo[i].key=="preview"){
			materials.push(promo[i].url);
		}
		if(console_name=="vita" && vita_promo_check>1) i=promo.length
	}
	var mp4_urls = [], pic_urls =[];
	for(var i in materials){
		if(materials[i].match(/\.mp4\?country/)!=null){
			mp4_urls.push(materials[i]);
		}
		if(materials[i].match(/(\.jpg$|\.png$)/)!=null){
			pic_urls.push(materials[i]);
		}
	}
	var elem_str = GenVideoImgElemStr(mp4_urls,pic_urls);
	return elem_str;
}

function GenVideoImgElemStr(mp4_urls,pic_urls,pic_names){
	var video_a = [], image_a =[];
	for(var i in mp4_urls){
		var video_str = "<div><video src='"+mp4_urls[i]+"' controls></video></div>"
		video_a.push(video_str);
	}
	for(var i in pic_urls){
		var image_str = "<img src='js/gray530.jpg' class='lazy' data-original='"+pic_urls[i]+"' >";
		if(pic_names!=undefined){
			var image_name_str = "<div class='pic_name'><a href='"+pic_urls[i]+"' target='_blank'>"+pic_names[i]+"</a></div>";
			image_str = image_name_str + image_str;
		}
		image_str = "<div class='pic'>" + image_str + "</div>";
		image_a.push(image_str);
	}
	var elem_str = video_a.join("") + image_a.join("");
	return elem_str;
}

function HrefStr(urls){
	/* ( urls[even] is url , urls[odd] is name ) */
	var href_a = [];
	for(var i=0;i<urls.length/2; i++){
		var href_str = "<a href='"+urls[(i*2)]+"' target='_blank'>"+urls[(i*2)+1]+"</a><br>"
		href_a.push(href_str);
	}
	var str = href_a.join("");
	return str;
}

function GetPageData(url,data_type){
	var d = $.Deferred();
	$.ajax({
		type: "GET",
		url: "ajax.php?url=" + url
	}).done(function(data){
		if(data==""){
			data = null;
		}else if(data.indexOf("HTTP request failed")<0){
			if(data_type=="xml"){
				try{
					data = $.parseXML(data);
				}catch(e){
					var byte_str = string_to_utf8_bytes(data);
					var hex_str = bytes_to_hex_string(byte_str);
					hex_str = hex_str.replace(/(00)/g,"");
					var byte_str2 = hex_string_to_bytes(hex_str);
					data = utf8_bytes_to_string(byte_str2);
					$.parseXML(data)
				}
			}else if(data_type=="json"){
				data = $.parseJSON(data);
			}
		}else{
			data = null;
		}
		d.resolve(data);
	}).fail(function(data){
		d.resolve(null);
	});
	return d.promise();
}

function ReTmdbCheck(){
	if(console_name!=null && console_name!=undefined && title_id!=undefined){
		$(".tmdb").remove();
		$("#output2").empty();
		if(console_name=="ps3" || console_name=="ps4"){
			PS3PS4_TmdbCheck().then(
				function(data){
					var def = new $.Deferred();
					if(console_name=="ps3"){
						PS3_TmdbOut(data,def);
					}else{
						PS4_TmdbOut(data,def);
					}
					return def.promise();
				},function(){
					$(".tmdb").append(notfound);
					return $.Deferred().resolve().promise();
				}
			);
		}
	}
}

function ReUpdateCheck(){
	if(console_name!=null && console_name!=undefined && title_id!=undefined){
		$(".update").remove();
		$("#output3").empty();
		if(console_name=="psp" || console_name=="ps3"){
			$.Deferred().resolve().promise().then(
				function(){
					var def = new $.Deferred();
					PSPPS3_UpdateCheck(def);
					return def.promise();
				}
			).then(
				function(data){
					var def = new $.Deferred();
					PSPPS3_UpdateOut(data,def);
					return def.promise();
				},function(){
					$(".update").append(notfound);
				}
			);
		}else if(console_name=="vita"){
			PSVITA_UpdateCheck().then(
				function(data){
					var def = new $.Deferred();
					PSVITA_UpdateOut(data,def);
					return def.promise();
				},function(){
					$(".update").append(notfound);
				}
			);
		}else if(console_name=="ps4"){
			$.Deferred().resolve().promise().then(
				function(){
					var def = new $.Deferred();
					PS4_UpdateCheck(def);
					return def.promise();
				}
			).then(
				function(data){
					var def = new $.Deferred();
					PS4_UpdateOut(data,def);
					return def.promise();
				},function(){
					$(".update").append(notfound);
				}
			);
		}
	}
}

function ReChihiroCheck(){
	if($(".chihiro").length){
		$(".chihiro").remove();
		$(".valkyrie").remove();
		$("#output4").empty();
		ChihiroCheck(true);
	}else if((title_id!=undefined && titles.length) || (content_id!=null && content_id!=undefined)){
		$("#output4").empty();
		ChihiroCheck(true);
	}else if(title_id!=undefined && title_id.match(/^CUSA/)!=null){
		$("#output4").empty();
		ChihiroCheck(true);
	}
}


/* supports xml with "Char 0x0 out of allowed range" error (NPEB00900 tmdb) */
function string_to_utf8_bytes(str){
    var result = [];
    if(str == null) return result;
    for(var i = 0; i < str.length; i++){
        var c = str.charCodeAt(i);
        if(c <= 0x7f){
            result.push(c);
        }else if(c <= 0x07ff){
            result.push(((c >> 6) & 0x1F) | 0xC0);
            result.push((c & 0x3F) | 0x80);
        }else{
            result.push(((c >> 12) & 0x0F) | 0xE0);
            result.push(((c >> 6) & 0x3F) | 0x80);
            result.push((c & 0x3F) | 0x80);
        }
    }
    return result;
}
function byte_to_hex(byte_num){
	var digits = (byte_num).toString(16);
    if (byte_num < 16) return '0' + digits;
    return digits;
}
function bytes_to_hex_string(bytes){
	var	result = "";
	for (var i = 0; i < bytes.length; i++) {
		result += byte_to_hex(bytes[i]);
	}
	return result;
}
function hex_to_byte(hex_str){
	return parseInt(hex_str, 16);
}
function hex_string_to_bytes(hex_str){
	var	result = [];
	for (var i = 0; i < hex_str.length; i+=2) {
		result.push(hex_to_byte(hex_str.substr(i,2)));
	}
	return result;
}
function utf8_bytes_to_string(arr){
    if (arr == null)
        return null;
    var result = "";
    var i;
    while (i = arr.shift()) {
        if (i <= 0x7f) {
            result += String.fromCharCode(i);
        } else if (i <= 0xdf) {
            var c = ((i&0x1f)<<6);
            c += arr.shift()&0x3f;
            result += String.fromCharCode(c);
        } else if (i <= 0xe0) {
            var c = ((arr.shift()&0x1f)<<6)|0x0800;
            c += arr.shift()&0x3f;
            result += String.fromCharCode(c);
        } else {
            var c = ((i&0x0f)<<12);
            c += (arr.shift()&0x3f)<<6;
            c += arr.shift() & 0x3f;
            result += String.fromCharCode(c);
        }
    }
    return result;
}